# coding: utf-8

"""
    Gunbot SDK Python

    The Gunbot SDK for Python enables you to programmatically interact with Gunbot, a self-hosted trading bot for crypto, ETFs and stocks.  It's a single API client with which you can control automated trading operations on many exchanges. Gunbot includes unique built-in strategies, it can also run custom strategy code in js. This client lets you orchestrate and monitor trading bots.  The API client accepts and returns data in JSON format.  It uses standard HTTP response codes to indicate request outcomes:  - **200 OK** – The request was successful   - **400 Bad Request** – The request was invalid or cannot be processed   - **401 Unauthorized** – Authentication failed or the user lacks permissions   - **500 Internal Server Error** – A server-side error occurred    **Gunbot Workflow**  1. Add the trading pair to the configuration with a valid strategy.   2. Start the core to activate trading operations.    After completing these steps you can access market-data and trading endpoints. Gunbot will actively monitor and execute strategies for the specified pairs.  **Encryption Helpers**  Gunbot uses password encryption. Refer to the original documentation for helper snippets in JavaScript (Browser/Node.js), Bash and Python.  **Supported Exchanges**  Gunbot ships with native connectors for more than two dozen exchanges, covering spot, futures and on-chain derivatives.   | Exchange | Spot | Futures / Perps | DeFi (on-chain) | Extra notes | | --- | :---: | :---: | :---: | --- | | **Binance** | ✔️ | ✔️ (USD-M & COIN-M) |  | Largest liquidity | | **Binance US** | ✔️ |  |  | US-regulated arm | | **Bitget** | ✔️ | ✔️ (USDT & UM perps) |  |  | | **Bybit** | ✔️ | ✔️ (USDT & inverse perps) |  |  | | **OKX** | ✔️ | ✔️ (Perps & dated futures) |  |  | | **Kraken** | ✔️ | ✔️ (via Kraken Futures) |  |  | | **KuCoin** | ✔️ |  |  |  | | **Gate.io** | ✔️ |  |  |  | | **MEXC** | ✔️ |  |  |  | | **BingX** | ✔️ |  |  |  | | **Crypto.com** | ✔️ |  |  |  | | **Huobi Global** | ✔️ |  |  |  | | **Bitfinex** | ✔️ |  |  |  | | **HitBTC** | ✔️ |  |  |  | | **Coinbase Advanced Trade** | ✔️ |  |  | Former Coinbase Pro | | **CEX.io** | ✔️ |  |  |  | | **Poloniex** | ✔️ |  |  |  | | **Alpaca** (stocks & crypto) | ✔️ |  |  |  | | **dYdX (v3/v4)** |  | ✔️ | ✔️ | Perpetual DEX | | **HyperLiquid** | ✔️ | ✔️ | ✔️ | DeFi perps | | **PancakeSwap** |  | ✔️ | ✔️ | BSC DEX | | **Bitmex / Bitmex Testnet** |  | ✔️ |  |  |  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@gunbot.freshdesk.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class OHLCVData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'close': 'list[float]',
        'high': 'list[float]',
        'low': 'list[float]',
        'volume': 'list[float]',
        'open': 'list[float]'
    }

    attribute_map = {
        'close': 'close',
        'high': 'high',
        'low': 'low',
        'volume': 'volume',
        'open': 'open'
    }

    def __init__(self, close=None, high=None, low=None, volume=None, open=None):  # noqa: E501
        """OHLCVData - a model defined in Swagger"""  # noqa: E501
        self._close = None
        self._high = None
        self._low = None
        self._volume = None
        self._open = None
        self.discriminator = None
        if close is not None:
            self.close = close
        if high is not None:
            self.high = high
        if low is not None:
            self.low = low
        if volume is not None:
            self.volume = volume
        if open is not None:
            self.open = open

    @property
    def close(self):
        """Gets the close of this OHLCVData.  # noqa: E501


        :return: The close of this OHLCVData.  # noqa: E501
        :rtype: list[float]
        """
        return self._close

    @close.setter
    def close(self, close):
        """Sets the close of this OHLCVData.


        :param close: The close of this OHLCVData.  # noqa: E501
        :type: list[float]
        """

        self._close = close

    @property
    def high(self):
        """Gets the high of this OHLCVData.  # noqa: E501


        :return: The high of this OHLCVData.  # noqa: E501
        :rtype: list[float]
        """
        return self._high

    @high.setter
    def high(self, high):
        """Sets the high of this OHLCVData.


        :param high: The high of this OHLCVData.  # noqa: E501
        :type: list[float]
        """

        self._high = high

    @property
    def low(self):
        """Gets the low of this OHLCVData.  # noqa: E501


        :return: The low of this OHLCVData.  # noqa: E501
        :rtype: list[float]
        """
        return self._low

    @low.setter
    def low(self, low):
        """Sets the low of this OHLCVData.


        :param low: The low of this OHLCVData.  # noqa: E501
        :type: list[float]
        """

        self._low = low

    @property
    def volume(self):
        """Gets the volume of this OHLCVData.  # noqa: E501


        :return: The volume of this OHLCVData.  # noqa: E501
        :rtype: list[float]
        """
        return self._volume

    @volume.setter
    def volume(self, volume):
        """Sets the volume of this OHLCVData.


        :param volume: The volume of this OHLCVData.  # noqa: E501
        :type: list[float]
        """

        self._volume = volume

    @property
    def open(self):
        """Gets the open of this OHLCVData.  # noqa: E501


        :return: The open of this OHLCVData.  # noqa: E501
        :rtype: list[float]
        """
        return self._open

    @open.setter
    def open(self, open):
        """Sets the open of this OHLCVData.


        :param open: The open of this OHLCVData.  # noqa: E501
        :type: list[float]
        """

        self._open = open

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OHLCVData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OHLCVData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
